
_test:

;PT2257_Vol_CTRL__Lib_v1_0.c,34 :: 		void test(char err) {
;PT2257_Vol_CTRL__Lib_v1_0.c,35 :: 		if(err == _I2C_TIMEOUT_RD) {
	MOVF        FARG_test_err+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_test0
;PT2257_Vol_CTRL__Lib_v1_0.c,36 :: 		UART1_Write(MESSAGE1); //RA0_bit=1;
	MOVLW       _MESSAGE1+0
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,37 :: 		}
L_test0:
;PT2257_Vol_CTRL__Lib_v1_0.c,38 :: 		if(err == _I2C_TIMEOUT_WR) {
	MOVF        FARG_test_err+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_test1
;PT2257_Vol_CTRL__Lib_v1_0.c,39 :: 		UART1_Write(MESSAGE2); //RA1_bit=1;
	MOVLW       _MESSAGE2+0
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,40 :: 		}
L_test1:
;PT2257_Vol_CTRL__Lib_v1_0.c,41 :: 		}
L_end_test:
	RETURN      0
; end of _test

_PT2257_Init:

;PT2257_Vol_CTRL__Lib_v1_0.c,43 :: 		void PT2257_Init(void) {
;PT2257_Vol_CTRL__Lib_v1_0.c,44 :: 		I2C1_SetTimeoutCallback(1000, &test);
	MOVLW       232
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeout+0 
	MOVLW       3
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeout+1 
	MOVLW       0
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeout+2 
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeout+3 
	MOVLW       _test+0
	MOVWF       FARG_I2C1_SetTimeoutCallback_i2c1_timeout+0 
	MOVLW       hi_addr(_test+0)
	MOVWF       FARG_I2C1_SetTimeoutCallback_i2c1_timeout+1 
	MOVLW       FARG_test_err+0
	MOVWF       FARG_I2C1_SetTimeoutCallback_i2c1_timeout+2 
	MOVLW       hi_addr(FARG_test_err+0)
	MOVWF       FARG_I2C1_SetTimeoutCallback_i2c1_timeout+3 
	CALL        _I2C1_SetTimeoutCallback+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,45 :: 		}
L_end_PT2257_Init:
	RETURN      0
; end of _PT2257_Init

_increase:

;PT2257_Vol_CTRL__Lib_v1_0.c,47 :: 		void increase(void) {
;PT2257_Vol_CTRL__Lib_v1_0.c,48 :: 		volume++;
	INFSNZ      PT2257_Vol_CTRL__Lib_v1_0_volume+0, 1 
	INCF        PT2257_Vol_CTRL__Lib_v1_0_volume+1, 1 
;PT2257_Vol_CTRL__Lib_v1_0.c,49 :: 		if (volume > 79) { volume = 79; }
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       PT2257_Vol_CTRL__Lib_v1_0_volume+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__increase12
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_volume+0, 0 
	SUBLW       79
L__increase12:
	BTFSC       STATUS+0, 0 
	GOTO        L_increase2
	MOVLW       79
	MOVWF       PT2257_Vol_CTRL__Lib_v1_0_volume+0 
	MOVLW       0
	MOVWF       PT2257_Vol_CTRL__Lib_v1_0_volume+1 
L_increase2:
;PT2257_Vol_CTRL__Lib_v1_0.c,51 :: 		writeVolume(volume);
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_volume+0, 0 
	MOVWF       FARG_writeVolume+0 
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_volume+1, 0 
	MOVWF       FARG_writeVolume+1 
	CALL        _writeVolume+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,53 :: 		if (mute) {
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_mute+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_increase3
;PT2257_Vol_CTRL__Lib_v1_0.c,54 :: 		mute = false;
	CLRF        PT2257_Vol_CTRL__Lib_v1_0_mute+0 
;PT2257_Vol_CTRL__Lib_v1_0.c,55 :: 		writeMute(mute);
	CLRF        FARG_writeMute+0 
	CALL        _writeMute+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,56 :: 		}
L_increase3:
;PT2257_Vol_CTRL__Lib_v1_0.c,57 :: 		}
L_end_increase:
	RETURN      0
; end of _increase

_decrease:

;PT2257_Vol_CTRL__Lib_v1_0.c,59 :: 		void decrease(void) {
;PT2257_Vol_CTRL__Lib_v1_0.c,60 :: 		volume--;
	MOVLW       1
	SUBWF       PT2257_Vol_CTRL__Lib_v1_0_volume+0, 1 
	MOVLW       0
	SUBWFB      PT2257_Vol_CTRL__Lib_v1_0_volume+1, 1 
;PT2257_Vol_CTRL__Lib_v1_0.c,61 :: 		if (volume < 0)volume = 0;
	MOVLW       128
	XORWF       PT2257_Vol_CTRL__Lib_v1_0_volume+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decrease14
	MOVLW       0
	SUBWF       PT2257_Vol_CTRL__Lib_v1_0_volume+0, 0 
L__decrease14:
	BTFSC       STATUS+0, 0 
	GOTO        L_decrease4
	CLRF        PT2257_Vol_CTRL__Lib_v1_0_volume+0 
	CLRF        PT2257_Vol_CTRL__Lib_v1_0_volume+1 
L_decrease4:
;PT2257_Vol_CTRL__Lib_v1_0.c,63 :: 		writeVolume(volume);
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_volume+0, 0 
	MOVWF       FARG_writeVolume+0 
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_volume+1, 0 
	MOVWF       FARG_writeVolume+1 
	CALL        _writeVolume+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,65 :: 		if (mute) {
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_mute+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_decrease5
;PT2257_Vol_CTRL__Lib_v1_0.c,66 :: 		mute = false;
	CLRF        PT2257_Vol_CTRL__Lib_v1_0_mute+0 
;PT2257_Vol_CTRL__Lib_v1_0.c,67 :: 		writeMute(mute);
	CLRF        FARG_writeMute+0 
	CALL        _writeMute+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,68 :: 		}
L_decrease5:
;PT2257_Vol_CTRL__Lib_v1_0.c,69 :: 		}
L_end_decrease:
	RETURN      0
; end of _decrease

_toggleMute:

;PT2257_Vol_CTRL__Lib_v1_0.c,71 :: 		void toggleMute(void) {
;PT2257_Vol_CTRL__Lib_v1_0.c,72 :: 		if (mute) mute = false;
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_mute+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_toggleMute6
	CLRF        PT2257_Vol_CTRL__Lib_v1_0_mute+0 
	GOTO        L_toggleMute7
L_toggleMute6:
;PT2257_Vol_CTRL__Lib_v1_0.c,73 :: 		else mute = true;
	MOVLW       1
	MOVWF       PT2257_Vol_CTRL__Lib_v1_0_mute+0 
L_toggleMute7:
;PT2257_Vol_CTRL__Lib_v1_0.c,74 :: 		writeMute(mute);
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_mute+0, 0 
	MOVWF       FARG_writeMute+0 
	CALL        _writeMute+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,75 :: 		}
L_end_toggleMute:
	RETURN      0
; end of _toggleMute

_serialPrintStateJSON:

;PT2257_Vol_CTRL__Lib_v1_0.c,77 :: 		void serialPrintStateJSON(void) {
;PT2257_Vol_CTRL__Lib_v1_0.c,78 :: 		UART1_Write_Text(" Volume dB:");
	MOVLW       ?lstr1_PT2257_Vol_CTRL__Lib_v1_0+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr1_PT2257_Vol_CTRL__Lib_v1_0+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,79 :: 		IntToStr(volume, VOLUME_TXT);
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_volume+0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_volume+1, 0 
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _VOLUME_TXT+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_VOLUME_TXT+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,80 :: 		UART1_Write_Text(VOLUME_TXT);
	MOVLW       _VOLUME_TXT+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_VOLUME_TXT+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,81 :: 		UART1_Write(TAB);
	MOVLW       9
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,82 :: 		UART1_Write_Text(" Mute:");
	MOVLW       ?lstr2_PT2257_Vol_CTRL__Lib_v1_0+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr2_PT2257_Vol_CTRL__Lib_v1_0+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,83 :: 		IntToStr(mute, VOLUME_TXT);
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_mute+0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVLW       0
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _VOLUME_TXT+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_VOLUME_TXT+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,84 :: 		UART1_Write_Text(VOLUME_TXT);
	MOVLW       _VOLUME_TXT+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_VOLUME_TXT+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,85 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr3_PT2257_Vol_CTRL__Lib_v1_0+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr3_PT2257_Vol_CTRL__Lib_v1_0+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,86 :: 		}
L_end_serialPrintStateJSON:
	RETURN      0
; end of _serialPrintStateJSON

_level:

;PT2257_Vol_CTRL__Lib_v1_0.c,88 :: 		unsigned char level(int dB) {
;PT2257_Vol_CTRL__Lib_v1_0.c,91 :: 		volume=dB;
	MOVF        FARG_level_dB+0, 0 
	MOVWF       PT2257_Vol_CTRL__Lib_v1_0_volume+0 
	MOVF        FARG_level_dB+1, 0 
	MOVWF       PT2257_Vol_CTRL__Lib_v1_0_volume+1 
;PT2257_Vol_CTRL__Lib_v1_0.c,92 :: 		if (dB > 79) { dB = 79; }
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       FARG_level_dB+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__level18
	MOVF        FARG_level_dB+0, 0 
	SUBLW       79
L__level18:
	BTFSC       STATUS+0, 0 
	GOTO        L_level8
	MOVLW       79
	MOVWF       FARG_level_dB+0 
	MOVLW       0
	MOVWF       FARG_level_dB+1 
L_level8:
;PT2257_Vol_CTRL__Lib_v1_0.c,94 :: 		b = (dB / 10); //get the second digit
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_level_dB+0, 0 
	MOVWF       R0 
	MOVF        FARG_level_dB+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_S+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__level+0 
	MOVF        R1, 0 
	MOVWF       FLOC__level+1 
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_level_dB+0, 0 
	MOVWF       R0 
	MOVF        FARG_level_dB+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_S+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
;PT2257_Vol_CTRL__Lib_v1_0.c,96 :: 		b = b & 0b0000111; //limit the most significant digit to 3 bit (7)
	MOVLW       7
	ANDWF       FLOC__level+0, 0 
	MOVWF       R4 
	MOVF        FLOC__level+1, 0 
	MOVWF       R5 
	MOVLW       0
	ANDWF       R5, 1 
;PT2257_Vol_CTRL__Lib_v1_0.c,98 :: 		return (b << 4) | a; //return both numbers in one byte (0BBBAAAA)
	MOVLW       4
	MOVWF       R3 
	MOVF        R4, 0 
	MOVWF       R2 
	MOVF        R3, 0 
L__level19:
	BZ          L__level20
	RLCF        R2, 1 
	BCF         R2, 0 
	ADDLW       255
	GOTO        L__level19
L__level20:
	MOVF        R2, 0 
	IORWF       R0, 0 
	MOVWF       R0 
;PT2257_Vol_CTRL__Lib_v1_0.c,99 :: 		}
L_end_level:
	RETURN      0
; end of _level

_writeVolume:

;PT2257_Vol_CTRL__Lib_v1_0.c,102 :: 		void writeVolume(int dB) {
;PT2257_Vol_CTRL__Lib_v1_0.c,103 :: 		unsigned char bbbaaaa = level(dB);
	MOVF        FARG_writeVolume_dB+0, 0 
	MOVWF       FARG_level_dB+0 
	MOVF        FARG_writeVolume_dB+1, 0 
	MOVWF       FARG_level_dB+1 
	CALL        _level+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,104 :: 		unsigned char aaaa = bbbaaaa & 0b00001111;
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       writeVolume_aaaa_L0+0 
;PT2257_Vol_CTRL__Lib_v1_0.c,105 :: 		unsigned char bbb = (bbbaaaa >> 4) & 0b00001111;
	MOVF        R0, 0 
	MOVWF       writeVolume_bbb_L0+0 
	RRCF        writeVolume_bbb_L0+0, 1 
	BCF         writeVolume_bbb_L0+0, 7 
	RRCF        writeVolume_bbb_L0+0, 1 
	BCF         writeVolume_bbb_L0+0, 7 
	RRCF        writeVolume_bbb_L0+0, 1 
	BCF         writeVolume_bbb_L0+0, 7 
	RRCF        writeVolume_bbb_L0+0, 1 
	BCF         writeVolume_bbb_L0+0, 7 
	MOVLW       15
	ANDWF       writeVolume_bbb_L0+0, 1 
;PT2257_Vol_CTRL__Lib_v1_0.c,108 :: 		I2C1_Start();
	CALL        _I2C1_Start+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,109 :: 		I2C1_Wr(PT2257_ADDR);      // 0x88
	MOVLW       136
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,110 :: 		I2C1_Wr(EVC_2CH_10 | bbb);
	MOVLW       224
	IORWF       writeVolume_bbb_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,111 :: 		I2C1_Wr(EVC_2CH_1 | aaaa);
	MOVLW       208
	IORWF       writeVolume_aaaa_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,112 :: 		I2C1_Stop();
	CALL        _I2C1_Stop+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,114 :: 		}
L_end_writeVolume:
	RETURN      0
; end of _writeVolume

_writeMute:

;PT2257_Vol_CTRL__Lib_v1_0.c,116 :: 		void writeMute(bool state) {
;PT2257_Vol_CTRL__Lib_v1_0.c,117 :: 		I2C1_Start();
	CALL        _I2C1_Start+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,118 :: 		I2C1_Wr(PT2257_ADDR);   //0x88
	MOVLW       136
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,119 :: 		I2C1_Wr(EVC_MUTE | (state & 0b00000001));
	MOVLW       1
	ANDWF       FARG_writeMute_state+0, 0 
	MOVWF       R0 
	MOVLW       120
	IORWF       R0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,120 :: 		I2C1_Stop();
	CALL        _I2C1_Stop+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,121 :: 		}
L_end_writeMute:
	RETURN      0
; end of _writeMute

_off:

;PT2257_Vol_CTRL__Lib_v1_0.c,123 :: 		void off(void) {
;PT2257_Vol_CTRL__Lib_v1_0.c,124 :: 		I2C1_Start();
	CALL        _I2C1_Start+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,125 :: 		I2C1_Wr(PT2257_ADDR);       //0x88
	MOVLW       136
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,126 :: 		I2C1_Wr(EVC_OFF);
	MOVLW       255
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,127 :: 		I2C1_Stop();
	CALL        _I2C1_Stop+0, 0
;PT2257_Vol_CTRL__Lib_v1_0.c,128 :: 		}
L_end_off:
	RETURN      0
; end of _off

_getVolume:

;PT2257_Vol_CTRL__Lib_v1_0.c,130 :: 		int getVolume(void){
;PT2257_Vol_CTRL__Lib_v1_0.c,131 :: 		return volume;
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_volume+0, 0 
	MOVWF       R0 
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_volume+1, 0 
	MOVWF       R1 
;PT2257_Vol_CTRL__Lib_v1_0.c,132 :: 		}
L_end_getVolume:
	RETURN      0
; end of _getVolume

_getMute:

;PT2257_Vol_CTRL__Lib_v1_0.c,134 :: 		bool getMute(void){
;PT2257_Vol_CTRL__Lib_v1_0.c,135 :: 		return mute;
	MOVF        PT2257_Vol_CTRL__Lib_v1_0_mute+0, 0 
	MOVWF       R0 
;PT2257_Vol_CTRL__Lib_v1_0.c,136 :: 		}
L_end_getMute:
	RETURN      0
; end of _getMute
