#line 1 "C:/Users/Leonardo/Documents/Elettronica 2014/Progetti Pic Compilatore 6.0.0/Mikro C 6.0.0/18F2550/PT2257_I2C_EncodRot_PriorityThread_3.0/PT2257_Volume_CTRL/PT2257_Vol_CTRL__Lib_v1_0.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/stdbool.h"



 typedef char _Bool;
#line 1 "c:/users/leonardo/documents/elettronica 2014/progetti pic compilatore 6.0.0/mikro c 6.0.0/18f2550/pt2257_i2c_encodrot_prioritythread_3.0//pt2257_volume_ctrl/pt2257_vol_ctrl__lib_v1_0.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/stdbool.h"
#line 58 "c:/users/leonardo/documents/elettronica 2014/progetti pic compilatore 6.0.0/mikro c 6.0.0/18f2550/pt2257_i2c_encodrot_prioritythread_3.0//pt2257_volume_ctrl/pt2257_vol_ctrl__lib_v1_0.h"
 void test(char);
 void PT2257_Init(void);
 unsigned char static level(int);
 void writeVolume(int);
 void toggleMute(void);
 void writeMute( _Bool );
 void off(void);
 void increase(void);
 void decrease(void);

 int getVolume(void);
  _Bool  getMute(void);
 void serialPrintStateJSON(void);
#line 26 "C:/Users/Leonardo/Documents/Elettronica 2014/Progetti Pic Compilatore 6.0.0/Mikro C 6.0.0/18F2550/PT2257_I2C_EncodRot_PriorityThread_3.0/PT2257_Volume_CTRL/PT2257_Vol_CTRL__Lib_v1_0.c"
const char MESSAGE1[]=" !! ERROR on READ I2C bus, control PT2257 chip !! \r\n";
const char MESSAGE2[]=" !! ERROR on WRITE I2C bus, control PT2257 chip !! \r\n";

static int volume = 40;
static  _Bool  mute =  0 ;

unsigned char VOLUME_TXT[6];

void test(char err) {
if(err == _I2C_TIMEOUT_RD) {
 UART1_Write(MESSAGE1);
 }
if(err == _I2C_TIMEOUT_WR) {
 UART1_Write(MESSAGE2);
 }
}

void PT2257_Init(void) {
 I2C1_SetTimeoutCallback(1000, &test);
}

void increase(void) {
 volume++;
 if (volume > 79) { volume = 79; }

 writeVolume(volume);

 if (mute) {
 mute =  0 ;
 writeMute(mute);
 }
}

void decrease(void) {
 volume--;
 if (volume < 0)volume = 0;

 writeVolume(volume);

 if (mute) {
 mute =  0 ;
 writeMute(mute);
 }
}

void toggleMute(void) {
 if (mute) mute =  0 ;
 else mute =  1 ;
 writeMute(mute);
}

void serialPrintStateJSON(void) {
 UART1_Write_Text(" Volume dB:");
 IntToStr(volume, VOLUME_TXT);
 UART1_Write_Text(VOLUME_TXT);
 UART1_Write( 9 );
 UART1_Write_Text(" Mute:");
 IntToStr(mute, VOLUME_TXT);
 UART1_Write_Text(VOLUME_TXT);
 UART1_Write_Text("\r\n");
}

unsigned char level(int dB) {
 unsigned int b;
 unsigned int a;
 volume=dB;
 if (dB > 79) { dB = 79; }

 b = (dB / 10);
 a = (dB % 10);
 b = b & 0b0000111;

 return (b << 4) | a;
}


void writeVolume(int dB) {
 unsigned char bbbaaaa = level(dB);
 unsigned char aaaa = bbbaaaa & 0b00001111;
 unsigned char bbb = (bbbaaaa >> 4) & 0b00001111;


 I2C1_Start();
 I2C1_Wr( 0x88 );
 I2C1_Wr( 0b11100000  | bbb);
 I2C1_Wr( 0b11010000  | aaaa);
 I2C1_Stop();

}

void writeMute( _Bool  state) {
 I2C1_Start();
 I2C1_Wr( 0x88 );
 I2C1_Wr( 0b01111000  | (state & 0b00000001));
 I2C1_Stop();
}

void off(void) {
 I2C1_Start();
 I2C1_Wr( 0x88 );
 I2C1_Wr( 0b11111111 );
 I2C1_Stop();
}

int getVolume(void){
 return volume;
}

 _Bool  getMute(void){
 return mute;
}
