
_Interrupt:

;PT2257_I2C_EncodRot_PriorityThread_3.0.c,61 :: 		void Interrupt() iv 0x0008 ics ICS_AUTO {
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,63 :: 		if (TMR2IF_bit){
	BTFSS       TMR2IF_bit+0, BitPos(TMR2IF_bit+0) 
	GOTO        L_Interrupt0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,64 :: 		intcount++;
	INCF        _intcount+0, 1 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,65 :: 		if(intcount >= 100){ // enter here every 10mS
	MOVLW       100
	SUBWF       _intcount+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L_Interrupt1
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,66 :: 		intcount=0;
	CLRF        _intcount+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,68 :: 		loop10ms++; //IMPORTANT VARIABLE BECAUSE MANAGE THREADS PRIORITY IN MAIN
	INCF        _loop10ms+0, 1 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,69 :: 		if(loop10ms >= 10)  // ENTER HERE EVERY 1 SEC
	MOVLW       10
	SUBWF       _loop10ms+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L_Interrupt2
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,71 :: 		PORTA.B3 = ~PORTA.B3;  // LED BLINK EVERY SECOND
	BTG         PORTA+0, 3 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,72 :: 		loop10ms=0;
	CLRF        _loop10ms+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,73 :: 		sec++;
	INCF        _sec+0, 1 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,74 :: 		}
L_Interrupt2:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,75 :: 		}
L_Interrupt1:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,76 :: 		TMR2IF_bit = 0;
	BCF         TMR2IF_bit+0, BitPos(TMR2IF_bit+0) 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,78 :: 		} // END TIMER 2 INT
L_Interrupt0:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,80 :: 		} // END INTERRUPT FUNCTIONS
L_end_Interrupt:
L__Interrupt29:
	RETFIE      1
; end of _Interrupt

_InitTimer2:

;PT2257_I2C_EncodRot_PriorityThread_3.0.c,82 :: 		void InitTimer2(){
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,83 :: 		T2CON	 = 0x25;
	MOVLW       37
	MOVWF       T2CON+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,84 :: 		TMR2IE_bit	 = 1;
	BSF         TMR2IE_bit+0, BitPos(TMR2IE_bit+0) 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,85 :: 		PR2		 = 250;
	MOVLW       250
	MOVWF       PR2+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,86 :: 		INTCON	 = 0xC0;
	MOVLW       192
	MOVWF       INTCON+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,87 :: 		}
L_end_InitTimer2:
	RETURN      0
; end of _InitTimer2

_InitHardware:

;PT2257_I2C_EncodRot_PriorityThread_3.0.c,89 :: 		void InitHardware() {
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,90 :: 		TRISA = 0b00000011 ;   // =0 OUTPUT or PORTA = 0x00;
	MOVLW       3
	MOVWF       TRISA+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,91 :: 		TRISB = 0b00111100;   // set B5,B4,B3,B0 as input,other as Output
	MOVLW       60
	MOVWF       TRISB+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,92 :: 		TRISC = 0;
	CLRF        TRISC+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,93 :: 		TRISC.TRISC7 = 1;  // RX - UART1
	BSF         TRISC+0, 7 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,94 :: 		TRISC.TRISC6 = 0;  // TX - UART1
	BCF         TRISC+0, 6 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,95 :: 		PORTA=0;           // off all Port A pins
	CLRF        PORTA+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,96 :: 		PORTB=0;           // off all Port B pins
	CLRF        PORTB+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,99 :: 		LATC=0x00;         // off all Port C pins
	CLRF        LATC+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,100 :: 		CMCON = 0x07;      // Disable comparators
	MOVLW       7
	MOVWF       CMCON+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,101 :: 		ADCON0=0x00;       // Disable all Analogical/Digital Converters
	CLRF        ADCON0+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,102 :: 		ADCON1=0b00001111; // Disable Analog functions Configure AN pins as digital
	MOVLW       15
	MOVWF       ADCON1+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,103 :: 		I2C1_Init(400000);
	MOVLW       12
	MOVWF       SSPADD+0 
	CALL        _I2C1_Init+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,104 :: 		}
L_end_InitHardware:
	RETURN      0
; end of _InitHardware

_main:

;PT2257_I2C_EncodRot_PriorityThread_3.0.c,106 :: 		void main() {
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,109 :: 		InitHardware();
	CALL        _InitHardware+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,111 :: 		UART1_Init(9600);
	BSF         BAUDCON+0, 3, 0
	MOVLW       2
	MOVWF       SPBRGH+0 
	MOVLW       8
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,112 :: 		Delay_ms(100);
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L_main3:
	DECFSZ      R13, 1, 1
	BRA         L_main3
	DECFSZ      R12, 1, 1
	BRA         L_main3
	DECFSZ      R11, 1, 1
	BRA         L_main3
	NOP
	NOP
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,113 :: 		UART1_Write(CLS);// Erase screen terminal,it is an option on Vbray Terminal!
	MOVLW       12
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,114 :: 		PT2257_Init();
	CALL        _PT2257_Init+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,115 :: 		Delay_ms(100);
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L_main4:
	DECFSZ      R13, 1, 1
	BRA         L_main4
	DECFSZ      R12, 1, 1
	BRA         L_main4
	DECFSZ      R11, 1, 1
	BRA         L_main4
	NOP
	NOP
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,118 :: 		Vol=40;
	MOVLW       40
	MOVWF       main_Vol_L0+0 
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,120 :: 		UART1_Write_Text(" TEST PT2257 12C DEVICE VOLUME CONTROL \r\n");
	MOVLW       ?lstr1_PT2257_I2C_EncodRot_PriorityThread_3.0+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr1_PT2257_I2C_EncodRot_PriorityThread_3.0+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,121 :: 		UART1_Write_Text(" MCU 18F2550 EXT.XITAL 20MHZ PLL/5 \r\n");
	MOVLW       ?lstr2_PT2257_I2C_EncodRot_PriorityThread_3.0+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr2_PT2257_I2C_EncodRot_PriorityThread_3.0+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,122 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr3_PT2257_I2C_EncodRot_PriorityThread_3.0+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr3_PT2257_I2C_EncodRot_PriorityThread_3.0+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,125 :: 		writeVolume(Vol); // Initialization Volume level
	MOVF        main_Vol_L0+0, 0 
	MOVWF       FARG_writeVolume+0 
	MOVLW       0
	MOVWF       FARG_writeVolume+1 
	CALL        _writeVolume+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,126 :: 		serialPrintStateJSON(); // print Volume and Mute status
	CALL        _serialPrintStateJSON+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,127 :: 		InitTimer2();
	CALL        _InitTimer2+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,129 :: 		do{
L_main5:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,132 :: 		if( (CLK == 0) && (TD==0) ) {  // IF YOU TURN ON THE LEFT SIDE
	BTFSC       RB4_bit+0, BitPos(RB4_bit+0) 
	GOTO        L_main11
	BTFSC       RB3_bit+0, BitPos(RB3_bit+0) 
	GOTO        L_main11
L__main27:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,133 :: 		if(Vol>0) {
	MOVF        main_Vol_L0+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_main12
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,134 :: 		Vol-- ; writeVolume((int)Vol);
	DECF        main_Vol_L0+0, 1 
	MOVF        main_Vol_L0+0, 0 
	MOVWF       FARG_writeVolume+0 
	MOVLW       0
	MOVWF       FARG_writeVolume+1 
	CALL        _writeVolume+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,135 :: 		serialPrintStateJSON();
	CALL        _serialPrintStateJSON+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,136 :: 		while(CLK==0);//removes disturbances in the phase of the rotary transition
L_main13:
	BTFSC       RB4_bit+0, BitPos(RB4_bit+0) 
	GOTO        L_main14
	GOTO        L_main13
L_main14:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,137 :: 		}
L_main12:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,138 :: 		}
L_main11:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,140 :: 		if( (CLK == 0) && (TD==1) ){  // IF YOU TURN ON THE LEFT SIDE
	BTFSC       RB4_bit+0, BitPos(RB4_bit+0) 
	GOTO        L_main17
	BTFSS       RB3_bit+0, BitPos(RB3_bit+0) 
	GOTO        L_main17
L__main26:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,141 :: 		if(Vol<79) {
	MOVLW       79
	SUBWF       main_Vol_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_main18
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,142 :: 		Vol++  ; writeVolume((int)Vol);
	INCF        main_Vol_L0+0, 1 
	MOVF        main_Vol_L0+0, 0 
	MOVWF       FARG_writeVolume+0 
	MOVLW       0
	MOVWF       FARG_writeVolume+1 
	CALL        _writeVolume+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,143 :: 		serialPrintStateJSON();
	CALL        _serialPrintStateJSON+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,144 :: 		while(CLK==0);//removes disturbances in the phase of the rotary transition
L_main19:
	BTFSC       RB4_bit+0, BitPos(RB4_bit+0) 
	GOTO        L_main20
	GOTO        L_main19
L_main20:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,145 :: 		}
L_main18:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,146 :: 		}
L_main17:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,147 :: 		if(SELECTION_SW1==0) {
	BTFSC       RB5_bit+0, BitPos(RB5_bit+0) 
	GOTO        L_main21
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,148 :: 		while(SELECTION_SW1==0);
L_main22:
	BTFSC       RB5_bit+0, BitPos(RB5_bit+0) 
	GOTO        L_main23
	GOTO        L_main22
L_main23:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,149 :: 		toggleMute();
	CALL        _toggleMute+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,150 :: 		serialPrintStateJSON();
	CALL        _serialPrintStateJSON+0, 0
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,151 :: 		}
L_main21:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,155 :: 		if((loop10ms % 5) == 2) {
	MOVLW       5
	MOVWF       R4 
	MOVF        _loop10ms+0, 0 
	MOVWF       R0 
	CALL        _Div_8X8_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_main24
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,158 :: 		} // END THREAD 2
L_main24:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,161 :: 		if((loop10ms % 3) == 3) {
	MOVLW       3
	MOVWF       R4 
	MOVF        _loop10ms+0, 0 
	MOVWF       R0 
	CALL        _Div_8X8_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_main25
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,164 :: 		} // END THREAD 3
L_main25:
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,168 :: 		}while(1);
	GOTO        L_main5
;PT2257_I2C_EncodRot_PriorityThread_3.0.c,169 :: 		}   // end main
L_end_main:
	GOTO        $+0
; end of _main
